// 
// ־ͨ - ʾ - ZigBee/IR
// 

#include "3DDisplayCommand.h"

_3DDisplayCommand::_3DDisplayCommand()
{
	SetDevice(CommandData::Devices::_3D_Display);
}

byte* _3DDisplayCommand::CMD_IR_CarLicenseMode_1to4(byte d1, byte d2, byte d3, byte d4)
{
	SetCommand(0xFF, 0x20, d1, d2, d3, d4);
	return GetIRCommandArray();
}

byte* _3DDisplayCommand::CMD_IR_CarLicenseMode_5to6_XY(byte d5, byte d6, byte x, byte y)
{
	SetCommand(0xFF, 0x10, d5, d6, x, y);
	return GetIRCommandArray();
}

byte* _3DDisplayCommand::CMD_IR_DisplayDestence(byte dis)
{
	if (dis >= 99)
		SetCommand(0xFF, 0x11, 0x09, 0x09, 0x00, 0x00);
	else
		SetCommand(0xFF, 0x11, (dis / 10), (dis % 10), 0x00, 0x00);
	return GetIRCommandArray();
}

byte* _3DDisplayCommand::CMD_IR_DisplayShape(Shape shape)
{
	SetCommand(0xFF, 0x12, (byte)shape, 0x00, 0x00, 0x00);
	return GetIRCommandArray();
}

byte* _3DDisplayCommand::CMD_IR_DisplayColor(Color color)
{
	SetCommand(0xFF, 0x13, (byte)color, 0x00, 0x00, 0x00);
	return GetIRCommandArray();
}

byte* _3DDisplayCommand::CMD_IR_DisplayAlarmSign(AlarmSign sign)
{
	SetCommand(0xFF, 0x14, (byte)sign, 0x00, 0x00, 0x00);
	return GetIRCommandArray();
}

byte* _3DDisplayCommand::CMD_IR_DisplayTrafficSign(TrafficSign sign)
{
	SetCommand(0xFF, 0x15, (byte)sign, 0x00, 0x00, 0x00);
	return GetIRCommandArray();
}

byte* _3DDisplayCommand::CMD_IR_DisplayDefaultInfo()
{
	SetCommand(0xFF, 0x16, 0x01, 0x00, 0x00, 0x00);
	return GetIRCommandArray();
}

byte* _3DDisplayCommand::CMD_IR_SetTextColor(byte r, byte g, byte b)
{
	SetCommand(0xFF, 0x17, 0x01, r, g, b);
	return GetIRCommandArray();
}

byte* _3DDisplayCommand::CMD_IR_CustomTextAdd(byte text1, byte text2, bool last_char)
{
	SetCommand(0xFF, 0x31, text1, text2, (last_char ? 0x55 : 0x00), 0x00);
	return GetIRCommandArray();
}

byte* _3DDisplayCommand::CMD_IR_CustomTextStop(bool clear_display)
{
	SetCommand(0xFF, 0x32, (clear_display ? 0x02 : 0x01), 0x00, 0x00, 0x00);
	return GetIRCommandArray();
}

byte* _3DDisplayCommand::CMD_ZIGBEE_CustomTextAdd(byte text1, byte text2, bool last_char)
{
	SetCommand(0x31, text1, text2, (last_char ? 0x55 : 0x00));
	return GetCommandArray();
}

byte* _3DDisplayCommand::CMD_ZIGBEE_CustomTextStop(bool clear_display)
{
	SetCommand(0x32, (clear_display ? 0x02 : 0x01));
	return GetCommandArray();
}
