// 3DDisplayCommand.h

#ifndef _3DDISPLAYCOMMAND_h
#define _3DDISPLAYCOMMAND_h

#if defined(ARDUINO) && ARDUINO >= 100
	#include "arduino.h"
#else
	#include "WProgram.h"
#endif

#include "CommandEncoder.h"

class _3DDisplayCommand : private CommandEncoder
{
public:
	enum class Shape
	{
		Rectangle = 0x01,
		Round = 0x02,
		Triangle = 0x03,
		Rhombus = 0x04,
		Star = 0x05
	};
	enum class Color
	{
		Red = 0x01,
		Green = 0x02,
		Blue = 0x03,
		Yellow = 0x04,
		Pink = 0x05,
		Cyan = 0x06,
		Black = 0x07,
		White = 0x08
	};
	enum class AlarmSign
	{
		School = 0x01,
		UnderConstruction = 0x02,
		RodeFallsDown = 0x03,
		KeepDistence = 0x04,
		NoDrinkDrive = 0x05,
		NoThrowRubbish = 0x06
	};
	enum class TrafficSign
	{
		GoStraight = 0x01,
		TurnLeft = 0x02,
		TurnRight = 0x03,
		TurnAround = 0x04,
		NoStraight = 0x05,
		DoNotEnter = 0x06
	};
public:
	_3DDisplayCommand();
public:
	byte* CMD_IR_CarLicenseMode_1to4(byte d1, byte d2, byte d3, byte d4);
	byte* CMD_IR_CarLicenseMode_5to6_XY(byte d5, byte d6, byte x, byte y);
	byte* CMD_IR_DisplayDestence(byte dis);
	byte* CMD_IR_DisplayShape(Shape shape);
	byte* CMD_IR_DisplayColor(Color color);
	byte* CMD_IR_DisplayAlarmSign(AlarmSign sign);
	byte* CMD_IR_DisplayTrafficSign(TrafficSign sign);
	byte* CMD_IR_DisplayDefaultInfo();
	byte* CMD_IR_SetTextColor(byte r, byte g, byte b);
	byte* CMD_IR_CustomTextAdd(byte text1, byte text2, bool last_char = false);
	byte* CMD_IR_CustomTextStop(bool clear_display);
	byte* CMD_ZIGBEE_CustomTextAdd(byte text1, byte text2, bool last_char = false);
	byte* CMD_ZIGBEE_CustomTextStop(bool clear_display);
};

#endif

