// AlarmTowerCommand.h

#ifndef _ALARMTOWERCOMMAND_h
#define _ALARMTOWERCOMMAND_h

#if defined(ARDUINO) && ARDUINO >= 100
	#include "arduino.h"
#else
	#include "WProgram.h"
#endif

#include "CommandEncoder.h"

class AlarmTowerCommand : private CommandEncoder
{
public:
	AlarmTowerCommand();
public:
	byte* CMD_DefaultIRAlarm();
	byte* CMD_IRAlarm(byte d1, byte d2, byte d3, byte d4, byte d5, byte d6);
	byte* CMD_ChangeOpenCode_1to3(byte d1, byte d2, byte d3);
	byte* CMD_ChangeOpenCode_4to6(byte d4, byte d5, byte d6);
	byte* CMD_QueryRescuePosition();
public:
	bool IsAlarmTowerCommand(byte* cmd);
	byte ReadRescuePosition(byte* cmd);
};

#endif

