// TFTCommand.h

#ifndef _TFTCOMMAND_h
#define _TFTCOMMAND_h

#if defined(ARDUINO) && ARDUINO >= 100
	#include "arduino.h"
#else
	#include "WProgram.h"
#endif

#include "CommandEncoder.h"

class TFTCommand : private CommandEncoder
{
public:
	enum class TrafficSign
	{
		GoStraight = 0x01,
		TurnLeft = 0x02,
		TurnRight = 0x03,
		TurnAround = 0x04,
		NoStraight = 0x05,
		DoNotEnter = 0x06
	};
public:
	TFTCommand();
public:
	void UsingA();
	void UsingB();
public:
	//Picture Mode
	byte* CMD_DisplaySpecPicture(byte no);	//Range: 0x01~0x20
	byte* CMD_PageUp();
	byte* CMD_PageDown();
	byte* CMD_AutoPaging();
	//Car License Mode
	byte* CMD_CarLicenseMode_1to3(byte d1, byte d2, byte d3);
	byte* CMD_CarLicenseMode_4to6(byte d4, byte d5, byte d6);
	//Timer Mode
	byte* CMD_TimerOn();
	byte* CMD_TimerOff();
	byte* CMD_TimerClear();
	//HEX Mode
	byte* CMD_DisplayHex(uint32_t hex);
	//Distence Mode
	byte* CMD_DisplayDistence(uint16_t dis);
	//Traffic Sign Mode
	byte* CMD_DisplayTrafficSign(TrafficSign sign);
};

#endif

