// VoiceRepotCommand.h

#ifndef _VOICEREPOTCOMMAND_h
#define _VOICEREPOTCOMMAND_h

#if defined(ARDUINO) && ARDUINO >= 100
	#include "arduino.h"
#else
	#include "WProgram.h"
#endif

#include "CommandEncoder.h"

/*
* ־
* 1. ݵĲѯݲѯĽᱻصǴӳ
* 2. ϳɣӳZigBee8λУݵ´˹޷ʵ֡
*/

class VoiceReportCommand : private CommandEncoder
{
private:
	const byte RT_VoiceCommand = 0x01;
	const byte RT_DateCommand = 0x02;
	const byte RT_TimeCommand = 0x03;
	const byte RT_WeatherTempCommand = 0x04;
public:
	enum class VoiceCmd
	{
		Fu_Qiang_Lu_Zhan = 0x00,	//ǿ·վ
		Min_Zhu_Lu_Zhan = 0x01,		//·վ
		Wen_Ming_Lu_Zhan = 0x02,	//·վ
		He_Xie_Lu_Zhan = 0x03,		//г·վ
		Ai_Guo_Lu_Zhan = 0x04,		//·վ
		Jing_Ye_Lu_Zhan = 0x05,		//ҵ·վ
		You_Shan_Lu_Zhan = 0x06		//·վ
	};

	enum class WeatherCmd
	{
		Wind = 0x00,		//
		Cloudy = 0x01,		//
		Sunny = 0x02,		//
		Snow = 0x03,		//Сѩ
		Rain = 0x04,		//С
		Overcast = 0x05		//
	};

	enum class TextEncoding
	{
		GB2312 = 0x00,
		GBK = 0x01,
		BIG5 = 0x02,
		Unicode = 0x03
	};
public:
	VoiceReportCommand();
public:
	byte* CMD_ReportSpecVoice(VoiceCmd type);
	byte* CMD_ReportRandomVoice();
	byte* CMD_SetRTCStartDate(uint16_t year, byte month, byte day);
	byte* CMD_ReadRTCDate();
	byte* CMD_SetRTCStartTime(byte hour, byte minute, byte second);
	byte* CMD_ReadRTCTime();
	byte* CMD_SetWeatherAndTemperature(WeatherCmd weather, byte temp);
	byte* CMD_QueryWeatherAndTemperator();
public:
	bool IsVoiceCommand(byte* cmd);
	bool IsVoiceAvailable(byte* cmd);
	bool ReadRTCDate(byte* cmd, uint16_t& year, byte& month, byte& day);
	bool ReadRTCTime(byte* cmd, byte& hour, byte& minute, byte& second);
	bool ReadWeatherAndTemperature(byte* cmd, WeatherCmd& weather, byte& temp);
};

#endif

